# Class CallHandle

java.lang.Object
com.codename1.call.CallHandle

public final class CallHandle extends Object

Who is on the other end: an address plus what kind of address it is.

The system uses both parts. A `CallHandleType.PHONE_NUMBER` is matched against the address book and may be reformatted for display, so it is worth passing E.164; a `CallHandleType.GENERIC` handle is shown verbatim. Passing a username as a phone number produces a call log entry the user cannot call back.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CallHandle(CallHandleType type, String value)`
  Creates a handle.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static CallHandle`
  `email(String address)`
  Convenience for an email address.
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `static CallHandle`
  `generic(String value)`
  Convenience for a username, room name or other opaque address.
  `CallHandleType`
  `getType()`
  What kind of address `getValue()` is.
  `String`
  `getValue()`
  The address itself.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `static CallHandle`
  `phone(String number)`
  Convenience for a telephone number.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CallHandle

    public CallHandle(CallHandleType type, String value)
    Creates a handle.
    Parameters:
      `type` - what kind of address `value` is; null is treated as `CallHandleType.GENERIC`
      `value` - the address itself, never null or empty
    Throws:
      `IllegalArgumentException` - if `value` is null or empty

- ## Method Details

  - ### phone

    public static CallHandle phone(String number)
    Convenience for a telephone number.
    Parameters:
      `number` - the number, ideally in E.164
    Returns:
      a phone-number handle

  - ### email

    public static CallHandle email(String address)
    Convenience for an email address.
    Parameters:
      `address` - the address
    Returns:
      an email handle

  - ### generic

    public static CallHandle generic(String value)
    Convenience for a username, room name or other opaque address.
    Parameters:
      `value` - the address, shown to the user verbatim
    Returns:
      a generic handle

  - ### getType

    public CallHandleType getType()
    What kind of address `getValue()` is. Never null.

  - ### getValue

    public String getValue()
    The address itself. Never null or empty.

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`